const rp = require('request-promise-native');

module.exports = function (configUrl) {

    const objrequest = {};

    objrequest.getEntities = function (id) {
        //control chamar
        const obj = Object.assign({url: configUrl + 'dialogflow/entities/'+id});
        return rp(obj);
    };


    objrequest.getEntity = function (id) {
        //control chamar
        const obj = Object.assign({url: configUrl + 'entities/'+id});
        return rp(obj);
    };

    objrequest.getKeywordsFromEntity =  function(entityModel){

        return new Promise((resolve) => {

            const executor = async () => {

                const entity = await objrequest.getEntity(entityModel.id);

                let data = [];

                entity.entries.forEach((item) => {
                    data = data.concat(item.synonyms);
                });

                resolve({key: entity, data: data});
            };

            executor();

        });

    };
    return objrequest;
};
